/*
 * The contents of this web application are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this web application except in compliance with 
 * the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the License.
 * 
 * The Original Code is owned by and the Initial Developer of the Original Code is 
 * Composite A/S (Danish business reg.no. 21744409). All Rights Reserved
 * 
 * Section 11 of the License is EXPRESSLY amended to include a provision stating 
 * that any dispute, including but not limited to disputes related to the enforcement 
 * of the License, to which Composite A/S as owner of the Original Code, as Initial 
 * Developer or in any other role, becomes a part to shall be governed by Danish law 
 * and be initiated before the Copenhagen City Court ("K�benhavns Byret")            
 */

using System;
using Composite.Data.Hierarchy;
using Composite.Data.Hierarchy.DataAncestorProviders;


namespace Composite.Data.Types
{
    /// <summary>    
    /// </summary>
    /// <exclude />
    [System.ComponentModel.EditorBrowsable(System.ComponentModel.EditorBrowsableState.Never)]
    [AutoUpdateble]
    [ImmutableTypeId("{FB2EAE51-1214-491d-8174-3A99DF90DFFA}")]
    [KeyPropertyName("Id")]
    [DataAncestorProvider(typeof(NoAncestorDataAncestorProvider))]
    [DataScope(DataScopeIdentifier.PublicName)]
    [Caching(CachingType.Full)]
    [NotReferenceable]
    public interface IVisualFunction : IData
	{
        /// <exclude />
        [ImmutableFieldId("{F8678EC3-FA5A-4141-9C93-130C93A49413}")]
        [StoreFieldType(PhysicalStoreFieldType.Guid)]
        Guid Id { get; set; }


        /// <exclude />
        [ImmutableFieldId("{6CED428C-6190-4176-9E6D-C6DBCF9BD4C3}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 256)]
        string Name { get; set; }


        /// <exclude />
        [ImmutableFieldId("{D6E1D464-1343-4f08-AB97-759D7DD1EB80}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 512)]
        string Namespace { get; set; }


        /// <exclude />
        [ImmutableFieldId("{A40492CA-BEB9-43cb-83CA-082889575A36}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 512)]
        string Description { get; set; }


        /// <exclude />
        [ImmutableFieldId("{4737CCE8-9302-438a-87B0-DF28C974DC57}")]
        [StoreFieldType(PhysicalStoreFieldType.String,256)]
        string TypeManagerName { get; set; }


        /// <exclude />
        [ImmutableFieldId("{FE3D5717-8F42-48e8-A089-AD431BEA1708}")]
        [StoreFieldType(PhysicalStoreFieldType.LargeString)]
        string XhtmlTemplate { get; set; }


        /// <exclude />
        [ImmutableFieldId("{92479348-53B0-410d-8200-B3C6D7AFE54E}")]
        [StoreFieldType(PhysicalStoreFieldType.Integer)]
        int MaximumItemsToList { get; set; }


        /// <exclude />
        [ImmutableFieldId("{3E41CE01-166F-41fb-A0FA-93EB5E3391DA}")]
        [StoreFieldType(PhysicalStoreFieldType.String, 64)]
        string OrderbyFieldName { get; set; }


        /// <exclude />
        [ImmutableFieldId("{790B0F2E-CAB7-4eea-9EB2-5E49C8DE7575}")]
        [StoreFieldType(PhysicalStoreFieldType.Boolean)]
        [DefaultFieldBoolValue(true)]
        bool OrderbyAscending { get; set; }
    }
}
