/*
 * The contents of this web application are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this web application except in compliance with 
 * the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the License.
 * 
 * The Original Code is owned by and the Initial Developer of the Original Code is 
 * Composite A/S (Danish business reg.no. 21744409). All Rights Reserved
 * 
 * Section 11 of the License is EXPRESSLY amended to include a provision stating 
 * that any dispute, including but not limited to disputes related to the enforcement 
 * of the License, to which Composite A/S as owner of the Original Code, as Initial 
 * Developer or in any other role, becomes a part to shall be governed by Danish law 
 * and be initiated before the Copenhagen City Court ("K�benhavns Byret")            
 */

using System;
using System.Web.UI;

namespace Composite.controls.helpers
{
    public partial class StyleFileLoaderControl : System.Web.UI.UserControl
    {
        public string adminRelativePath = "";

        protected void Page_Load(object sender, EventArgs e)
        {
            string path = Composite.Core.WebClient.UrlUtils.ResolveAdminUrl(adminRelativePath);
            string tagGoo = string.Format("<link rel='stylesheet' type='text/css' href='{0}'/>\n", path);

            Control headerElementsPlaceHolder = this.FindControl(this.Page, "HeaderPlaceHolder");
            if (headerElementsPlaceHolder == null) throw new InvalidOperationException("Missing 'HeaderPlaceHolder' placeholder on page");
            headerElementsPlaceHolder.Controls.Add(new LiteralControl(tagGoo));
        }


        private Control FindControl(Control toSearch, string idToFind)
        {
            Control c = toSearch.FindControl(idToFind);
            if (c == null && toSearch.Controls != null)
            {
                foreach (Control subControl in toSearch.Controls)
                {
                    c = FindControl(subControl, idToFind);
                    if (c != null) break;
                }
            }

            return c;
        }


    }
}